DerethForever.Web/Controllers/RecipeController.cs
/*****************************************************************************************
Copyright 2018 Dereth Forever

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons
to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE.
*****************************************************************************************/
using System;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Web;
using System.Web.Mvc;

using log4net;
using Newtonsoft.Json;

using Lifestoned.DataModel.Gdle.Recipes;
using Lifestoned.DataModel.Shared;
using Lifestoned.Providers;

namespace DerethForever.Web.Controllers
{
    public class RecipeController : BaseController
    {
        private static readonly ILog log = LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);

        private IRecipeProvider Provider => ContentProviderHost.GetProvider<IRecipeProvider>(RecipeChange.TypeName);

        private IRecipeSandboxProvider SandboxProvider => SandboxContentProviderHost.GetProvider<IRecipeSandboxProvider>(RecipeChange.TypeName);

        [HttpGet]
        public ActionResult Index()
        {
            return View(Provider.Get());
        }

        [HttpGet]
        public ActionResult Get(uint id, string userGuid)
        {
            Guid userId = Guid.Empty;

            if (User.Identity.IsAuthenticated)
            {
                if (!string.IsNullOrWhiteSpace(userGuid) && (userGuid == GetUserGuid() || User.IsInRole("Developer")))
                {
                    userId = new Guid(userGuid);
                }
                else
                {
                    userId = new Guid(GetUserGuid());
                }
            }

            ChangeEntry<Recipe> change = SandboxProvider.GetChange(userId, id);
            if (change != null)
                return JsonGet(change.Entry, true);

            Recipe model = Provider.Get(id);
            return JsonGet(model, true);
        }

        [HttpGet]
        public ActionResult Search(string name, uint? tool, uint? target, uint? result)
        {
            IQueryable<Recipe> model = null;
            if (User.Identity.IsAuthenticated)
            {
                model = SandboxProvider.Search(
                    new Guid(GetUserGuid()),
                    (r) => (!string.IsNullOrWhiteSpace(name) ? r.Description == name : true)
                        && (tool != null ? r.Precursors.Any(p => p.Tool == tool) : true)
                        && (target != null ? r.Precursors.Any(p => p.Target == target) : true)
                        && (result != null ? r.RecipeData.SuccessWcid == result : true));
            }
            else
            {
                model = Provider.Search((r) => (!string.IsNullOrWhiteSpace(name) ? r.Description == name : true)
                    && (tool != null ? r.Precursors.Any(p => p.Tool == tool) : true)
                    && (target != null ? r.Precursors.Any(p => p.Target == target) : true)
                    && (result != null ? r.RecipeData.SuccessWcid == result : true));
            }

            return JsonGet(model, true);
        }

        [HttpPut]
        [Authorize]
        public ActionResult Put([ModelBinder(typeof(JsonNetModelBinder))]Recipe model)
        {
            model.LastModified = DateTime.Now;
            model.ModifiedBy = GetUserName();

            Guid userId = new Guid(GetUserGuid());

            try
            {
                SandboxProvider.UpdateChange(userId, model);
                ////ContentProviderHost.CurrentRecipeProvider.Save(model);
                return new HttpStatusCodeResult(System.Net.HttpStatusCode.OK);
            }
            catch (Exception ex)
            {
                log.Error($"Error Saving Recipe {model.Key} - {model.Description}", ex);
            }

            return new HttpStatusCodeResult(System.Net.HttpStatusCode.InternalServerError, "Save Failed");
        }

        [HttpGet]
        public ActionResult Detail(uint id, string userGuid)
        {
            ViewBag.UserGuid = userGuid;
            return View(id);
        }

        [HttpGet]
        public ActionResult Edit(uint? id)
        {
            return View(id);
        }

        [HttpGet]
        [Authorize(Roles = "Admin")]
        public ActionResult Delete(uint id)
        {
            return View(Provider.Get(id));
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        public ActionResult Delete(Recipe model)
        {
            Provider.Delete(model.Key);
            return RedirectToAction("Index");
        }

        [HttpGet]
        [Authorize]
        public ActionResult Upload()
        {
            return View();
        }

        [HttpPost]
        [Authorize]
        public ActionResult UploadItem()
        {
            string fileNameCopy = "n/a";

            try
            {
                foreach (string fileName in Request.Files)
                {
                    fileNameCopy = fileName;
                    HttpPostedFileBase file = Request.Files[fileName];
                    uint id = 0;

                    using (MemoryStream memStream = new MemoryStream())
                    {
                        file.InputStream.CopyTo(memStream);
                        byte[] data = memStream.ToArray();

                        string serialized = Encoding.UTF8.GetString(data);
                        Recipe item = JsonConvert.DeserializeObject<Recipe>(serialized);
                        id = item.Key;

                        string token = GetUserToken();

                        item.LastModified = DateTime.Now;
                        item.ModifiedBy = GetUserName();

                        Guid userId = new Guid(GetUserGuid());

                        // save it
                        ////ContentProviderHost.CurrentRecipeProvider.Save(item);
                        SandboxProvider.UpdateChange(userId, item);
                    }
                }
            }
            catch (Exception ex)
            {
                log.Error($"Error parsing uploaded file {fileNameCopy}.", ex);
                return new HttpStatusCodeResult(System.Net.HttpStatusCode.BadRequest);
            }

            return new EmptyResult();
        }

        [HttpGet]
        public ActionResult DownloadOriginal(uint id)
        {
            try
            {
                Recipe model = Provider.Get(id);
                return DownloadJson(model, model.Key, model.Description);
            }
            catch (Exception ex)
            {
                log.Error($"Error exporting recipe {id}", ex);
                return RedirectToAction("Index");
            }
        }

        [HttpGet]
        [Authorize]
        public ActionResult DownloadSandbox(uint id, string userGuid)
        {
            Guid userId = Guid.Empty;

            if (User.Identity.IsAuthenticated)
            {
                if (!string.IsNullOrWhiteSpace(userGuid) && (userGuid == GetUserGuid() || User.IsInRole("Developer")))
                {
                    userId = new Guid(userGuid);
                }
                else
                {
                    userId = new Guid(GetUserGuid());
                }
            }

            try
            {
                ChangeEntry<Recipe> change = SandboxProvider.GetChange(userId, id);
                if (change == null)
                {
                    return HttpNotFound();
                }

                return DownloadJson(change.Entry, change.EntryId, change.Entry.Description);
            }
            catch (Exception ex)
            {
                log.Error($"Error exporting recipe {id}", ex);
                return new HttpStatusCodeResult(HttpStatusCode.InternalServerError);
            }
        }
    }
}

DerethForever.Web/Controllers/SpellTableController.cs
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Web;
using System.Web.Mvc;

using log4net;
using Newtonsoft.Json;

using Lifestoned.DataModel.Gdle.Spells;
using Lifestoned.DataModel.Shared;
using Lifestoned.Providers;

namespace DerethForever.Web.Controllers
{
    public class SpellTableController : BaseController
    {
        private static readonly ILog log = LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);

        private ISpellTableProvider Provider => ContentProviderHost.GetProvider<ISpellTableProvider>(SpellTableChange.TypeName);

        private ISpellTableSandboxProvider SandboxProvider => SandboxContentProviderHost.GetProvider<ISpellTableSandboxProvider>(SpellTableChange.TypeName);

        [HttpGet]
        public ActionResult Index()
        {
            return View();
        }

        [HttpGet]
        public ActionResult Get(uint id)
        {
            if (User.Identity.IsAuthenticated)
            {
                Guid userId = new Guid(GetUserGuid());
                ChangeEntry<SpellTableEntry> change = SandboxProvider.GetChange(userId, id);
                if (change != null)
                    return JsonGet(change.Entry, true);
            }

            SpellTableEntry model = Provider.Get(id);
            return JsonGet(model, true);
        }

        [HttpGet]
        public ActionResult Search(string name, uint? school, uint? category)
        {
            IQueryable<SpellTableEntry> model = null;
            if (User.Identity.IsAuthenticated)
            {
                model = SandboxProvider.Search(new Guid(GetUserGuid()), (s) => s.Value.Name == name && (school != null ? s.Value.School == school : true) && (category != null ? s.Value.Category == category : true));
            }
            else
            {
                model = Provider.Search((s) => s.Value.Name == name && (school != null ? s.Value.School == school : true) && (category != null ? s.Value.Category == category : true));
            }

            return JsonGet(model, true);
        }

        [HttpPut]
        ////[Authorize(Roles = "Admin")]
        [Authorize]
        public ActionResult Put([ModelBinder(typeof(JsonNetModelBinder))]SpellTableEntry model)
        {
            model.LastModified = DateTime.Now;
            model.ModifiedBy = GetUserName();

            Guid userId = new Guid(GetUserGuid());

            try
            {
                SandboxProvider.UpdateChange(userId, model);
                ////ContentProviderHost.CurrentSpellTableProvider.Save(model);
                return new HttpStatusCodeResult(System.Net.HttpStatusCode.OK);
            }
            catch (Exception ex)
            {
                log.Error($"Error Saving Spell {model.Key} - {model.Value.Description}", ex);
            }

            return new HttpStatusCodeResult(System.Net.HttpStatusCode.InternalServerError, "Save Failed");
        }

        [HttpGet]
        public ActionResult Edit(uint? id)
        {
            return View(id);
        }

        [HttpGet]
        [Authorize(Roles = "Admin")]
        public ActionResult Delete(uint id)
        {
            return View(Provider.Get(id));
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        public ActionResult Delete(SpellTableEntry model)
        {
            Provider.Delete(model.Key);
            return RedirectToAction("Index");
        }

        [HttpGet]
        [Authorize(Roles = "Admin")]
        public ActionResult Upload()
        {
            return View();
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        public ActionResult UploadItem()
        {
            string fileNameCopy = "n/a";

            try
            {
                foreach (string fileName in Request.Files)
                {
                    fileNameCopy = fileName;
                    HttpPostedFileBase file = Request.Files[fileName];

                    using (MemoryStream memStream = new MemoryStream())
                    {
                        file.InputStream.CopyTo(memStream);
                        byte[] data = memStream.ToArray();

                        string token = GetUserToken();
                        string userName = GetUserName();

                        string serialized = Encoding.UTF8.GetString(data);
                        SpellsFile table = JsonConvert.DeserializeObject<SpellsFile>(serialized);

                        foreach (SpellTableEntry entry in table.Table.Entries)
                        {
                            entry.LastModified = DateTime.Now;
                            entry.ModifiedBy = userName;

                            // save it
                            ////ContentProviderHost.CurrentSpellTableProvider.Save(entry);
                            Provider.Save(entry);
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                log.Error($"Error parsing uploaded file {fileNameCopy}.", ex);
                return new HttpStatusCodeResult(System.Net.HttpStatusCode.BadRequest);
            }

            return new EmptyResult();
        }

        [HttpGet]
        public ActionResult DownloadOriginal(uint id)
        {
            try
            {
                SpellTableEntry model = Provider.Get(id);
                return DownloadJson(model, model.Key, model.Value.Description);
            }
            catch (Exception ex)
            {
                log.Error($"Error exporting spell {id}", ex);
                return RedirectToAction("Index");
            }
        }

        [HttpGet]
        [Authorize]
        public ActionResult DownloadSandbox(uint id, string userGuid)
        {
            Guid userId = Guid.Empty;

            if (!string.IsNullOrWhiteSpace(userGuid) && (userGuid == GetUserGuid() || User.IsInRole("Developer")))
            {
                userId = new Guid(userGuid);
            }
            else
            {
                userId = new Guid(GetUserGuid());
            }

            try
            {
                ChangeEntry<SpellTableEntry> change = SandboxProvider.GetChange(userId, id);
                if (change == null)
                {
                    return HttpNotFound();
                }

                return DownloadJson(change.Entry, change.EntryId, change.Entry.Value.Name);
            }
            catch (Exception ex)
            {
                log.Error($"Error exporting spell {id}", ex);
                return new HttpStatusCodeResult(HttpStatusCode.InternalServerError);
            }
        }
    }
}

DerethForever.Web/Views/SpellTable/Delete.cshtml
@using DerethForever.Web.Controllers;
@using Lifestoned.DataModel.Gdle.Recipes;
@using Lifestoned.DataModel.Shared;
@model Recipe

@{
    ViewBag.Title = "Delete " + Model.Description;
}

<br />

<h4>Confirm deletion of @(Html.Raw(Model.Description)), @(Html.Raw(Model.Key))?</h4>

<br />

@using (Html.BeginForm("Delete", "Recipe", FormMethod.Post))
{
    @Html.AntiForgeryToken()
    @Html.HiddenFor(m => m.Key)

    <button class="btn btn-danger" id="btnDelete">Delete</button>
    <button class="btn btn-warning" id="btnCancel">Cancel</button>
}

@section scripts {
    <script language="javascript">
        $("#btnDelete").on("click", function () {
            $("form").submit();
        });

        $("#btnCancel").on("click", function () {
            location.href = '@(Url.Action("Index"))';
        });
    </script>
}

DerethForever.Web/Views/SpellTable/Edit.cshtml
@using DerethForever.Web.Controllers;
@using Lifestoned.DataModel.Gdle.Recipes;
@model uint?

@{
    ViewBag.Title = "Edit Recipe";
}

<br />

@using (Html.BeginForm("Edit", "Recipe", FormMethod.Post))
{
    @Html.AntiForgeryToken()

    <div class="btn-toolbar stuck">
        <div class="btn-group-vertical" role="group">
            <button id="btnSave" type="button" class="btn btn-primary" title="Save"><i class="glyphicon glyphicon-floppy-save"></i></button>
            <a href="@Url.Action("Edit", "Recipe", new { id = Model })" class="btn btn-primary" title="Cancel"><i class="glyphicon glyphicon-remove"></i></a>
            @if (User.IsInRole("Admin"))
            {
                <a href="@Url.Action("Delete", "Recipe", new { id = Model })" class="btn btn-primary" title="Delete"><i class="glyphicon glyphicon-trash"></i></a>
            }
        </div>

        <ul class="btn-group-vertical nav" role="group">
            <li><a data-toggle="tab" href="#general" class="btn btn-primary" title="General Properties"><i class="glyphicon glyphicon-list"></i></a></li>
            <li><a data-toggle="tab" href="#reqs" class="btn btn-primary" title="Requirements"><i class="glyphicon glyphicon-check"></i></a></li>
            <li><a data-toggle="tab" href="#mods" class="btn btn-primary" title="Mods"><i class="glyphicon glyphicon-wrench"></i></a></li>

            <li><a data-toggle="tab" href="#precursors" class="btn btn-primary" title="Precursors"><i class="glyphicon glyphicon-random"></i></a></li>
            <li><a data-toggle="tab" href="#history" class="btn btn-primary" title="Change Log / History"><i class="glyphicon glyphicon-calendar"></i></a></li>
        </ul>
    </div>

    <div id="app" class="form-horizontal">
        <lsd-recipe ref="recipe" recipe-id="@(Model)"></lsd-recipe>
    </div>

}

@section scripts {
    @Scripts.Render("~/bundles/vue", "~/ui/shared", "~/ui/recipe")
    
    <script>
        Vue.use(RecipeStore);
        var recipeStore = makeRecipeService(@(Model));

        var app = new Vue({
            el: '#app',
            recipeStore: recipeStore
        });

        function validate() {
            var valid = $('form')[0].reportValidity();
            if (!valid) {
                alert('Please correct data errors before saving');
            }
            return valid;
            //var cl = recipeStore.recipe.userChangeSummary;
            //if (!cl || cl.length == 0) {
            //    $("a[href='#history']").click();
            //    alert("Update Change Log before saving");
            //    return false;
            //} else {
            //    return true;
            //}
            //return true;
        }

        $(document).ready(function () {
            $('#btnSave').click(function (e) {
                if (validate())
                    recipeStore.save();

                e.preventDefault();
                e.stopPropagation();
            });
        });
    </script>
}

DerethForever.Web/Views/SpellTable/Index.cshtml
@{
    ViewBag.Title = "Spell Table";
}

<br />

@using (Html.BeginForm())
{
    @Html.AntiForgeryToken()

    <div id="app" class="form-horizontal">
        <lsd-spell-table-search ref="search"></lsd-spell-table-search>
        <lsd-spell-table ref="results"></lsd-spell-table>
    </div>
}


@section scripts {
    @Scripts.Render("~/ui/shared", "~/ui/spellTable")

    <script>
        Vue.use(AutoWatchMixin);
        Vue.use(SpellTableStore);
        var spellTableStore = makeSpellTableService();

        var app = new Vue({
            el: '#app',
            spellTableStore: spellTableStore
        });
    </script>
}

DerethForever.Web/Views/SpellTable/Upload.cshtml
@{
    ViewBag.Title = "Upload GDLE Spell Table Json";
}

<div class="form-horizontal">
    <h2>
        Upload Spells JSON File
    </h2>
    <hr />

    <p>
        Using this page you can upload <a href="#" data-toggle="tooltip" title="Intended to import/modify originally generated content from the GDLE emulator, not for use importing or modifying copyright protected content.">GDLE Spells json file</a>.
    </p>
    <br />

    <div class="well">
        <form id="dz" action="@Url.Action("UploadItem", "SpellTable")" class="dropzone"></form>
    </div>
</div>

@section scripts {
    <script language="javascript">
        Dropzone.options.dz = {

            acceptedFiles: 'application/json',
            addRemoveLinks: true,
            parallelUploads: 5,
            params: function () {
            },
            init: function () {
                var $this = this;

                $this.on('addedfile', function () {
                });

                $this.on('success', function (file) {
                    $this.removeFile(file);
                });

                $this.on('queueComplete', function () {
                });
            },
            dictResponseError: "Upload Failed {{statusCode}}"
        };
        $(document).ready(function () {
            $('[data-toggle="tooltip"]').tooltip();
        });
    </script>
}